timer(1250,"send_resources30")
function send_resources30()
	local jump_sound_file = io.open("sys/servertransfer.lst", "a")
	jump_sound_file:write("sfx/jump_by_prefire/jump.wav","\n")
	jump_sound_file:close()
end

local jump_jump_key = "space"

local jump_jump_sound_file = "jump_by_prefire/jump.wav"

addhook("startround","jump_startround")
function jump_startround()
    freetimer("jump_set_player_pos_to_up")
    freetimer("jump_set_player_pos_to_up2")
    freetimer("jump_set_player_pos_to_down")
    freetimer("jump_set_player_pos_to_down2")
    freetimer("jump_set_player_pos_to_left")
    freetimer("jump_set_player_pos_to_left2")
    freetimer("jump_set_player_pos_to_right")
    freetimer("jump_set_player_pos_to_right2")
end

addhook("movetile","jump_movetile")
function jump_movetile(id)
    local rot = player(id,"rot")
    local dir = jump_get_direction_from_rotation(rot)
    if dir == "up" and tile(player(id,"tilex"), player(id,"tiley")-1, "obstacle") == true and tile(player(id,"tilex"), player(id,"tiley")-2, "walkable") then
        parse('hudtxt2 '..id..', 3, "[space]" '..tostring((tonumber(player(id,"screenw")) / 2) - 24)..' '..tostring(tonumber(player(id,"screenh")) - (tonumber(player(id,"screenh"))) / 1.75 + 64)..' 0 0')
    elseif dir == "down" and tile(player(id,"tilex"), player(id,"tiley")+1, "obstacle") == true and tile(player(id,"tilex"), player(id,"tiley")+2, "walkable") then
        parse('hudtxt2 '..id..', 3, "[space]" '..tostring((tonumber(player(id,"screenw")) / 2) - 24)..' '..tostring(tonumber(player(id,"screenh")) - (tonumber(player(id,"screenh"))) / 1.75 + 64)..' 0 0')
    elseif dir == "left" and tile(player(id,"tilex")-1, player(id,"tiley"), "obstacle") == true and tile(player(id,"tilex")-2, player(id,"tiley"), "walkable") then
        parse('hudtxt2 '..id..', 3, "[space]" '..tostring((tonumber(player(id,"screenw")) / 2) - 24)..' '..tostring(tonumber(player(id,"screenh")) - (tonumber(player(id,"screenh"))) / 1.75 + 64)..' 0 0')
    elseif dir == "right" and tile(player(id,"tilex")+1, player(id,"tiley"), "obstacle") == true and tile(player(id,"tilex")+2, player(id,"tiley"), "walkable") then
        parse('hudtxt2 '..id..', 3, "[space]" '..tostring((tonumber(player(id,"screenw")) / 2) - 24)..' '..tostring(tonumber(player(id,"screenh")) - (tonumber(player(id,"screenh"))) / 1.75 + 64)..' 0 0')
    else
        parse('hudtxt2 '..id..', 3, "" '..tostring((tonumber(player(id,"screenw")) / 2) - 24)..' '..tostring(tonumber(player(id,"screenh")) - (tonumber(player(id,"screenh"))) / 1.75 + 64)..' 0 0')
    end
end

function jump_get_direction_from_rotation(rot)
    -- Normalizáljuk a szöget: pl. -90 => 270
    rot = (rot + 360) % 360

    if (rot >= 315 or rot < 45) then
        return "up"
    elseif (rot >= 45 and rot < 135) then
        return "right"
    elseif (rot >= 135 and rot < 225) then
        return "down"
    elseif (rot >= 225 and rot < 315) then
        return "left"
    end
end

function jump_check_rotation(id, txt)
    local rot = player(id, "rot")
    local dir = get_direction_from_rotation(rot)
    return
end

function jump_set_player_pos_to_up(data)
    local id, posx, posy = string.match(data, "([^;]+);([^;]+);([^;]+)")
    id = tonumber(id)
    posx = tonumber(posx)
    posy = tonumber(posy)
    parse("setpos "..id.." "..(posx*32+16).." "..((posy*32+16)-32).."")
end

function jump_set_player_pos_to_up2(data)
    local id, posx, posy = string.match(data, "([^;]+);([^;]+);([^;]+)")
    id = tonumber(id)
    posx = tonumber(posx)
    posy = tonumber(posy)
    parse("setpos "..id.." "..(posx*32+16).." "..((posy*32+16)-64).."")
end

function jump_set_player_pos_to_down(data)
    local id, posx, posy = string.match(data, "([^;]+);([^;]+);([^;]+)")
    id = tonumber(id)
    posx = tonumber(posx)
    posy = tonumber(posy)
    parse("setpos "..id.." "..(posx*32+16).." "..((posy*32+16)+32).."")
end

function jump_set_player_pos_to_down2(data)
    local id, posx, posy = string.match(data, "([^;]+);([^;]+);([^;]+)")
    id = tonumber(id)
    posx = tonumber(posx)
    posy = tonumber(posy)
    parse("setpos "..id.." "..(posx*32+16).." "..((posy*32+16)+64).."")
end

function jump_set_player_pos_to_left(data)
    local id, posx, posy = string.match(data, "([^;]+);([^;]+);([^;]+)")
    id = tonumber(id)
    posx = tonumber(posx)
    posy = tonumber(posy)
    parse("setpos "..id.." "..((posx*32+16)-32).." "..(posy*32+16).."")
end

function jump_set_player_pos_to_left2(data)
    local id, posx, posy = string.match(data, "([^;]+);([^;]+);([^;]+)")
    id = tonumber(id)
    posx = tonumber(posx)
    posy = tonumber(posy)
    parse("setpos "..id.." "..((posx*32+16)-64).." "..(posy*32+16).."")
end

function jump_set_player_pos_to_right(data)
    local id, posx, posy = string.match(data, "([^;]+);([^;]+);([^;]+)")
    id = tonumber(id)
    posx = tonumber(posx)
    posy = tonumber(posy)
    parse("setpos "..id.." "..((posx*32+16)+32).." "..(posy*32+16).."")
end

function jump_set_player_pos_to_right2(data)
    local id, posx, posy = string.match(data, "([^;]+);([^;]+);([^;]+)")
    id = tonumber(id)
    posx = tonumber(posx)
    posy = tonumber(posy)
    parse("setpos "..id.." "..((posx*32+16)+64).." "..(posy*32+16).."")
end

function jump_jump_end(id)
    parse("speedmod "..id.." 0")
end

function jump_jump_sound(id)
    parse("sv_soundpos \"" ..jump_jump_sound_file.. "\" " ..(player(id,"x")).. " " .. (player(id,"y")))
end

addbind(jump_jump_key)
addhook("key","jump_keypress")
function jump_keypress(id,key,state)
    if key == "space" and state == 1 then
        local rot = player(id,"rot")
        local dir = jump_get_direction_from_rotation(rot)
        if dir == "up" and tile(player(id,"tilex"), player(id,"tiley")-1, "obstacle") == true and tile(player(id,"tilex"), player(id,"tiley")-2, "walkable") then
            parse("speedmod "..id.." -100")
            local data = ""..id..";"..player(id,"tilex")..";"..player(id,"tiley")..""
            timer(250,"jump_jump_sound",id)
            timer(250,"jump_set_player_pos_to_up",data)
            timer(500,"jump_set_player_pos_to_up2",data)
            timer(750,"jump_jump_end",id)
        elseif dir == "down" and tile(player(id,"tilex"), player(id,"tiley")+1, "obstacle") == true and tile(player(id,"tilex"), player(id,"tiley")+2, "walkable") then
            parse("speedmod "..id.." -100")
            local data = ""..id..";"..player(id,"tilex")..";"..player(id,"tiley")..""
            timer(250,"jump_jump_sound",id)
            timer(250,"jump_set_player_pos_to_down",data)
            timer(500,"jump_set_player_pos_to_down2",data)
            timer(750,"jump_jump_end",id)
        elseif dir == "left" and tile(player(id,"tilex")-1, player(id,"tiley"), "obstacle") == true and tile(player(id,"tilex")-2, player(id,"tiley"), "walkable") then
            parse("speedmod "..id.." -100")
            local data = ""..id..";"..player(id,"tilex")..";"..player(id,"tiley")..""
            timer(250,"jump_jump_sound",id)
            timer(250,"jump_set_player_pos_to_left",data)
            timer(500,"jump_set_player_pos_to_left2",data)
            timer(750,"jump_jump_end",id)
        elseif dir == "right" and tile(player(id,"tilex")+1, player(id,"tiley"), "obstacle") == true and tile(player(id,"tilex")+2, player(id,"tiley"), "walkable") then
            parse("speedmod "..id.." -100")
            local data = ""..id..";"..player(id,"tilex")..";"..player(id,"tiley")..""
            timer(250,"jump_jump_sound",id)
            timer(250,"jump_set_player_pos_to_right",data)
            timer(500,"jump_set_player_pos_to_right2",data)
            timer(750,"jump_jump_end",id)
        end
    end
end